# Potential categories for individual files in operations.

#1. Filtering – Removing or selecting specific data points based on conditions.
#    Example: Low-pass filters, SQL WHERE clause, Pandas .query()

#2. Input/Output (I/O) – Reading from or writing to files, databases, or APIs.
#    Example: CSV parsing, database CRUD operations, JSON serialization

#3. Search – Finding specific data in a dataset.
#    Example: Binary search, fuzzy string matching, regex pattern search

#4. Sorting – Arranging data in a specified order.
#    Example: Quicksort, mergesort, radix sort

#5. Aggregation – Summarizing data by computing statistics.
#    Example: GroupBy operations, rolling averages, histograms

#6. Transformation – Changing data format, structure, or representation.
#    Example: One-hot encoding, log transformations, Fourier transforms

#7. Deduplication – Removing redundant or duplicate data.
#    Example: Hash-based duplicate detection, locality-sensitive hashing

#8. Compression – Reducing data size while preserving information.
#    Example: Run-length encoding, Huffman coding, Lempel-Ziv algorithms

#9. Normalization & Standardization – Adjusting data to a common scale.
#    Example: Min-max scaling, Z-score normalization

#10. Interpolation & Extrapolation – Estimating missing or future data points.
#    Example: Linear interpolation, polynomial extrapolation

#11. Merging & Joins – Combining multiple datasets into a single one.
#    Example: SQL joins, Pandas .merge(), hierarchical data merging

#12. Tokenization & Parsing – Splitting structured data into components.
#    Example: Lexical analysis, regular expression tokenization

#13. Encoding & Decoding – Converting data between different formats.
#    Example: Base64 encoding, UTF-8 to ASCII conversion

#14. Indexing – Structuring data to optimize lookups.
#    Example: B-Trees, inverted indices, hash maps

#15. Outlier Detection – Identifying abnormal data points.
#    Example: Z-score analysis, isolation forests, DBSCAN clustering
